import * as React from 'react';
import Animated from 'react-native-reanimated';
import { Layout, HeaderStyleInterpolator, Route, HeaderOptions, HeaderScene } from '../../types';
export declare type Scene<T> = {
    route: T;
    progress: Animated.Node<number>;
};
declare type Props = HeaderOptions & {
    layout: Layout;
    onGoBack?: () => void;
    title?: string;
    leftLabel?: string;
    scene: HeaderScene<Route>;
    styleInterpolator: HeaderStyleInterpolator;
};
declare type State = {
    titleLayout?: Layout;
    leftLabelLayout?: Layout;
};
export declare const getDefaultHeaderHeight: (layout: Layout) => number;
export default class HeaderSegment extends React.Component<Props, State> {
    static defaultProps: {
        headerBackground: () => JSX.Element;
    };
    state: State;
    private handleTitleLayout;
    private handleLeftLabelLayout;
    private getInterpolatedStyle;
    render(): JSX.Element;
}
export {};
