import * as React from 'react';
import { ViewProps, StyleProp, ViewStyle } from 'react-native';
import Animated from 'react-native-reanimated';
import { TransitionSpec, CardStyleInterpolator, Layout } from '../../types';
declare type Props = ViewProps & {
    active: boolean;
    closing?: boolean;
    transparent?: boolean;
    next?: Animated.Node<number>;
    current: Animated.Value<number>;
    layout: Layout;
    direction: 'horizontal' | 'vertical';
    onOpen: (isFinished: boolean) => void;
    onClose: (isFinished: boolean) => void;
    onTransitionStart?: (props: {
        closing: boolean;
    }) => void;
    onGestureBegin?: () => void;
    onGestureCanceled?: () => void;
    onGestureEnd?: () => void;
    children: React.ReactNode;
    overlayEnabled: boolean;
    shadowEnabled: boolean;
    gesturesEnabled: boolean;
    gestureResponseDistance?: {
        vertical?: number;
        horizontal?: number;
    };
    transitionSpec: {
        open: TransitionSpec;
        close: TransitionSpec;
    };
    styleInterpolator: CardStyleInterpolator;
    containerStyle?: StyleProp<ViewStyle>;
};
export default class Card extends React.Component<Props> {
    static defaultProps: {
        overlayEnabled: boolean;
        shadowEnabled: boolean;
        gesturesEnabled: boolean;
    };
    componentDidUpdate(prevProps: Props): void;
    private isVisible;
    private nextIsVisible;
    private isClosing;
    private isRunningAnimation;
    private clock;
    private direction;
    private layout;
    private distance;
    private gesture;
    private offset;
    private velocity;
    private gestureState;
    private isSwiping;
    private isSwipeCancelled;
    private isSwipeGesture;
    private toValue;
    private frameTime;
    private transitionVelocity;
    private transitionState;
    private runTransition;
    private velocitySignum;
    private extrapolatedPosition;
    private exec;
    private handleGestureEventHorizontal;
    private handleGestureEventVertical;
    componentWillUnmount(): void;
    private getInterpolatedStyle;
    private gestureActivationCriteria;
    private gestureRef;
    render(): JSX.Element;
}
export {};
