import * as React from 'react';
import Animated from 'react-native-reanimated';
import { Props as HeaderContainerProps } from '../Header/HeaderContainer';
import { Route, Layout, TransitionSpec, CardStyleInterpolator, HeaderStyleInterpolator, HeaderMode, GestureDirection, SceneDescriptor, NavigationProp, HeaderScene } from '../../types';
declare type ProgressValues = {
    [key: string]: Animated.Value<number>;
};
declare type Props = {
    navigation: NavigationProp;
    descriptors: {
        [key: string]: SceneDescriptor;
    };
    routes: Route[];
    openingRoutes: string[];
    closingRoutes: string[];
    onGoBack: (props: {
        route: Route;
    }) => void;
    onOpenRoute: (props: {
        route: Route;
    }) => void;
    onCloseRoute: (props: {
        route: Route;
    }) => void;
    getPreviousRoute: (props: {
        route: Route;
    }) => Route | undefined;
    getGesturesEnabled: (props: {
        route: Route;
    }) => boolean;
    renderHeader: (props: HeaderContainerProps) => React.ReactNode;
    renderScene: (props: {
        route: Route;
    }) => React.ReactNode;
    transparentCard?: boolean;
    headerMode: HeaderMode;
    direction: GestureDirection;
    cardOverlayEnabled?: boolean;
    cardShadowEnabled?: boolean;
    onTransitionStart?: (curr: {
        index: number;
    }, prev: {
        index: number;
    }) => void;
    onGestureBegin?: () => void;
    onGestureCanceled?: () => void;
    onGestureEnd?: () => void;
    transitionSpec: {
        open: TransitionSpec;
        close: TransitionSpec;
    };
    cardStyleInterpolator: CardStyleInterpolator;
    headerStyleInterpolator: HeaderStyleInterpolator;
};
declare type State = {
    routes: Route[];
    scenes: HeaderScene<Route>[];
    progress: ProgressValues;
    layout: Layout;
    floaingHeaderHeight: number;
};
export default class Stack extends React.Component<Props, State> {
    static getDerivedStateFromProps(props: Props, state: State): {
        routes: Route[];
        scenes: HeaderScene<Route>[];
        progress: ProgressValues;
    } | null;
    state: State;
    private handleLayout;
    private handleFloatingHeaderLayout;
    render(): JSX.Element;
}
export {};
