import * as React from 'react';
import Animated from 'react-native-reanimated';
import { Props as HeaderContainerProps } from '../Header/HeaderContainer';
import { Route, HeaderScene, GestureDirection, Layout, TransitionSpec, CardStyleInterpolator, HeaderMode, NavigationProp, HeaderStyleInterpolator } from '../../types';
declare type Props = {
    index: number;
    active: boolean;
    focused: boolean;
    closing: boolean;
    layout: Layout;
    current: Animated.Value<number>;
    previousScene?: HeaderScene<Route>;
    scene: HeaderScene<Route>;
    navigation: NavigationProp;
    transparentCard?: boolean;
    cardOverlayEnabled?: boolean;
    cardShadowEnabled?: boolean;
    gesturesEnabled?: boolean;
    direction: GestureDirection;
    getPreviousRoute: (props: {
        route: Route;
    }) => Route | undefined;
    renderHeader: (props: HeaderContainerProps) => React.ReactNode;
    renderScene: (props: {
        route: Route;
    }) => React.ReactNode;
    onOpenRoute: (props: {
        route: Route;
    }) => void;
    onCloseRoute: (props: {
        route: Route;
    }) => void;
    onGoBack: (props: {
        route: Route;
    }) => void;
    onTransitionStart?: (curr: {
        index: number;
    }, prev: {
        index: number;
    }) => void;
    onGestureBegin?: () => void;
    onGestureCanceled?: () => void;
    onGestureEnd?: () => void;
    gestureResponseDistance?: {
        vertical?: number;
        horizontal?: number;
    };
    transitionSpec: {
        open: TransitionSpec;
        close: TransitionSpec;
    };
    headerStyleInterpolator: HeaderStyleInterpolator;
    cardStyleInterpolator: CardStyleInterpolator;
    headerMode: HeaderMode;
    floaingHeaderHeight: number;
    hasCustomHeader: boolean;
};
export default class StackItem extends React.PureComponent<Props> {
    private handleOpen;
    private handleClose;
    private handleTransitionStart;
    render(): JSX.Element;
}
export {};
