import * as React from 'react';
import { NavigationProp, SceneDescriptor, NavigationConfig, Route } from '../../types';
declare type Descriptors = {
    [key: string]: SceneDescriptor;
};
declare type Props = {
    navigation: NavigationProp;
    descriptors: Descriptors;
    navigationConfig: NavigationConfig;
    onTransitionStart?: (curr: {
        index: number;
    }, prev: {
        index: number;
    }) => void;
    onGestureBegin?: () => void;
    onGestureCanceled?: () => void;
    onGestureEnd?: () => void;
    screenProps?: unknown;
};
declare type State = {
    routes: Route[];
    opening: string[];
    closing: string[];
    replacing: string[];
    descriptors: Descriptors;
};
declare class StackView extends React.Component<Props, State> {
    static getDerivedStateFromProps(props: Readonly<Props>, state: Readonly<State>): {
        routes: Route[];
        descriptors: Descriptors;
        opening?: undefined;
        closing?: undefined;
        replacing?: undefined;
    } | {
        routes: Route[];
        opening: string[];
        closing: string[];
        replacing: string[];
        descriptors: Descriptors;
    };
    state: State;
    private getGesturesEnabled;
    private getPreviousRoute;
    private renderScene;
    private renderHeader;
    private handleTransitionComplete;
    private handleGoBack;
    private handleOpenRoute;
    private handleCloseRoute;
    render(): JSX.Element;
}
export default StackView;
